import org.garret.consus.*;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Hashtable;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class HttpConnection {
    HttpServletRequest request;
    HttpServletResponse response;
    PrintWriter writer;
    Hashtable newParams;
    int length;

    void print(String s) throws IOException {
        length += s.length();
        writer.print(s);
    }

    String get(String name) {
        if (newParams != null) {
            String val = (String)newParams.get(name);
            if (val != null) {
                return val;
            }
        }
        return request.getParameter(name);
    }

    void addPair(String name, String val) {
        if (newParams == null) {
            newParams = new Hashtable();
        }
        newParams.put(name, val);
    }

    String getURI() {
        return request.getRequestURI();
    }

    void send() throws IOException {
        response.setContentLength(length);
        response.flushBuffer();
    }

    HttpConnection(HttpServletRequest request, HttpServletResponse response) throws IOException {
        this.request = request;
        this.response = response;
        writer = response.getWriter();
    }
}
