import java.awt.*;
import java.sql.*;
import org.garret.consus.*;

/** The dialog to create a new drawing. */
public class NewDialog extends Dialog {
    GraphEditor editor;
    TextField text;
    Button okButton;

    public NewDialog(GraphEditor editor) {
        super(editor, "New Record", true);
        this.editor = editor;
        setLayout(new FlowLayout(FlowLayout.CENTER, 1000, 40));
        addNotify();
        resize(insets().left + insets().right + 250, insets().top + insets().bottom + 150);
        text = new TextField(25);
        okButton = new Button("OK");
        add(text);
        add(okButton);
        show();
    }

    public void show() {
        java.awt.Point origin = editor.getLocationOnScreen();
        java.awt.Rectangle parentBounds = editor.bounds();
        java.awt.Rectangle myBounds = bounds();
        move(origin.x + (parentBounds.width - myBounds.width) / 2, origin.y + (parentBounds.height - myBounds.height) / 2);
        super.show();
    }

    public boolean handleEvent(Event event) {
        if (event.id == Event.ACTION_EVENT && (event.target == okButton || event.target == text)) {
            String str = text.getText().trim();
            if (str.length() == 0) {
                System.err.print("\007"); // beep
            } else {
                editor.addMenu.enable();
                handleEvent(new Event(this, Event.WINDOW_DESTROY, null));
                editor.newDrawing(str);
            }
            return true;
        } else if (event.id == Event.WINDOW_DESTROY) {
            hide();
            return true;
        }
        return super.handleEvent(event);
    }
}
