import java.awt.*;
import java.sql.*;
import org.garret.consus.*;

/** The dialog that allows users to select an existing drawing record from the database and open it. */
public class OpenDialog extends Dialog {
    GraphEditor editor;
    List list;
    Button okButton;

    public OpenDialog(GraphEditor editor, List drawings) {
        super(editor, "Open Record", true);
        this.editor = editor;
        setLayout(new FlowLayout(FlowLayout.CENTER, 1000, 20));
        addNotify();
        resize(insets().left + insets().right + 250, insets().top + insets().bottom + 150);
        list = drawings;
        okButton = new Button("OK");
        add(list);
        add(okButton);
        show();
    }

    public void show() {
        java.awt.Point origin = editor.getLocationOnScreen();
        java.awt.Rectangle parentBounds = editor.bounds();
        java.awt.Rectangle myBounds = bounds();
        move(origin.x + (parentBounds.width - myBounds.width) / 2, origin.y + (parentBounds.height - myBounds.height) / 2);
        super.show();
    }

    public boolean handleEvent(Event event) {
        if (event.id == Event.ACTION_EVENT && (event.target == okButton || event.target == list)) {
            String str = list.getSelectedItem();
            if (str == null) {
                System.err.print("\007"); // beep
            } else {
                editor.addMenu.enable();
                handleEvent(new Event(this, Event.WINDOW_DESTROY, null));
                editor.openDrawing(str);
            }
            return true;
        } else if (event.id == Event.WINDOW_DESTROY) {
            hide();
            return true;
        }
        return super.handleEvent(event);
    }
}
