/* Consus - Pure Java Object Relational Database Management System
 * Exception is thrown when the type convertion between a type specified by the programmer and a data type
 * in the database is not possible
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.consus;

/**
 * Exception is thrown when the type convertion between a type specified by programmer and a data type
 * in the database is not possible.
 */
public class ConsusIncompatibleTypesError extends java.sql.SQLException { 
    /** 
     * Default constructor
     */
    public ConsusIncompatibleTypesError() { 
	super("Requested type conversion is not possible");
    }
    
    /**
     * Constructor with information about the object that caused the fault.
     * @param obj source object which is failed to be converted to the requested type
     */
    public ConsusIncompatibleTypesError(Object obj) { 
	super("Requested type conversion is not possible from type " + obj.getClass().getName());
    }
}
