/* Consus - Pure Java Object Relational Database Management System
 * Exception thrown on client side when connection is refused by the server
 * Created by Konstantin Knizhnik, Apr 2000.
 */
package org.garret.consus;

import java.util.Properties;

/**
 * Exception thrown on client side when connection is refused by the server
 */
public class ConsusLoginRefusedException extends java.sql.SQLException { 
    String     host;
    int        port;
    Properties userInfo;
    
    /**
     * Constructor
     * @param host address of the server which refused the connection
     * @param port port to which connection was made
     * @param userInfo properties of the user
     */
    public ConsusLoginRefusedException(String host, int port, Properties userInfo) { 
	super("Connection is refused by server");
	this.host = host;
	this.port = port;
	this.userInfo = userInfo;
    }
}
