/* Consus - Pure Java Object Relational Database Management System
 * Exception caused by incorrect OID
 * Created by Konstantin Knizhnik, May 2000.
 */
package org.garret.consus;

/** 
 * This exception is thrown when an object with an incorrect OID is accessed
 * (OID = 0, nonexisted OID, OID of deleted object, ...)
 */
public class InvalidOIDError extends RuntimeException {
    int  oid;
    long pos;

    /**
     * Construct exception caused by using an invalid OID
     * @param oid of object
     * @param pos offset to the object in file + flags
     */
    public InvalidOIDError(int oid, long pos) { 
	super("Invalid OID " + oid + " = " + pos);
	this.oid = oid;
	this.pos = pos;
    }

    /**
     * Construct exception cause by using an invalid OID
     * @param oid of object
     */
    public InvalidOIDError(int oid) { 
	super("Invalid OID " + oid);
	this.oid = oid;
	this.pos = 0;
    }
}
