/* Consus - Pure Java Object Relational Database Management System
 * Exception thrown by the checkOutTable method when a merge conflict is detected
 * Created by Konstantin Knizhnik, May 2000.
 */
package org.garret.consus;

/**
 * Exception thrown by the checkOutTable method when a merge conflict is detected.
 */
public class MergeConflictException extends java.sql.SQLException { 
    public Object key;

    /**
     * Construct exception for the object with the specified key
     * @param obj key of the object which cause merge conflict.
     * The key is either the primary key of the object or the reference to the object.
     */
    public MergeConflictException(Object obj) { 
	super("Merge conflict for record " + obj);
	key = obj;
    }
}
