/* Consus - Pure Java Object Relational Database Management System
 * Abstract base class for all Persistent comparators
 * Created by Konstantin Knizhnik, Apr 2000.
 */

package org.garret.consus;

import java.util.Comparator;

/**
 * Abstract base class for all Persistent comparators
 */
public abstract class POComparator extends Persistent implements Comparator { 
    /**
     * Compare two objects.
     * @return value &lt; 0 if <code>o1</code> &lt; <code>o1</code>, 
     * 0 if <code>o1</code> == <code>o1</code>,  
     * value &gt; 0 if <code>o1</code> &gt; <code>o1</code>
     */
    public abstract int compare(Object o1, Object o2);
}

