/* Consus - Pure Java Object Relational Database Management System
 * Consus data source implementation.
 * Created by Konstantin Knizhnik, Mar 2001.
 */
package org.garret.consusx;

import java.io.*;
import java.sql.*;
import javax.sql.*;
import javax.naming.*;

public class ConsusDataSource implements DataSource, Referenceable, Serializable {
    public Reference getReference() throws NamingException 
    {
	Reference ref = new Reference(this.getClass().getName(),
				      "org.garret.jdbc.ObjectFactory",
				      null);
	ref.add(new StringRefAddr("serverName", getServerName()));
	ref.add(new StringRefAddr("databaseName", getDatabaseName()));
	return ref;
    }

    public Connection getConnection() throws SQLException 
    { 
	return getConnection(user, password);
    }

    public Connection getConnection(String username, String password) throws SQLException
    {
	String url;
	if (serverName == null) {
	    url = "jdbc:consus:" + databaseName;
	} else { 
	    url = "jdbc:consus-client:" + serverName + ":" + portNumber;
	}
	return DriverManager.getConnection(url, username, password);
    }

    public int getLoginTimeout() throws SQLException { return 0; }
    public void setLoginTimeout(int seconds) throws SQLException {}
    public PrintWriter getLogWriter() throws SQLException { return trace; }
    public void setLogWriter(PrintWriter out) throws SQLException { trace  = out; }

    public String getDatabaseName() { return databaseName; }
    public String getDataSourceName() { return dataSourceName; }
    public String getDescription() { return description; }
    public String getNetworkProtocol() { return networkProtocol; }
    public String getPassword() { return password; }
    public int    getPortNumber() { return portNumber; }
    public String getRoleName() { return roleName; }
    public String getServerName() { return serverName; }
    public String getUser() { return user; }

    public void   setDatabaseName(String databaseName) { this.databaseName = databaseName; }
    public void   setDataSourceName(String dataSourceName) { this.dataSourceName = dataSourceName; }
    public void   setDescription(String description) { this.description = description; }
    public void   setNetworkProtocol(String networkProtocol) { this.networkProtocol = networkProtocol; }
    public void   setPassword(String password) { this.password = password; }
    public void   setPortNumber(int portNumber) { this.portNumber = portNumber; }
    public void   setrRoleName(String roleName) { this.roleName = roleName; }
    public void   setServerName(String serverName) { this.serverName = serverName; }
    public void   setUser(String user) { this.user = user; }

    public String databaseName;
    public String dataSourceName;
    public String description;
    public String networkProtocol;
    public String password;
    public int    portNumber;
    public String roleName;
    public String serverName;
    public String user;

    PrintWriter   trace;

    public ConsusDataSource() {
	try { 
	    Class.forName("org.garret.consus.ConsusDriver");
	    Class.forName("org.garret.consus.ClientDriver");
	} catch (Exception x) {}
    }
}





