/* Consus - Pure Java Object Relational Database Management System
 * Consus transactional data source implementation.
 * Created by Konstantin Knizhnik, Mar 2001.
 */
package org.garret.consusx;

import java.io.*;
import java.sql.*;
import javax.sql.*;


public class ConsusXADataSource extends ConsusConnectionPoolDataSource
                                implements XADataSource 
{
    public XAConnection getXAConnection() throws SQLException { 
	return getXAConnection(user, password);
    }

    public synchronized XAConnection getXAConnection(String username, String password) throws SQLException
    {
	if (availableConnections == null) { 
	    return new ConsusXAConnection(this, username, password);
	} else { 
	    XAConnection conxn = (XAConnection)availableConnections;
	    availableConnections = availableConnections.next;
	    return conxn;
	}	
    }

    public Connection getConnection(String username, String password) throws SQLException
    {
	return getXAConnection().getConnection();
    }
}





