/* Consus - Pure Java Object Relational Database Management System
 * Node for loading NULL some predefined values
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;

class ConstantNode extends ExprNode { 
    boolean equalsNode(ExprNode node) { 
	return node.tag == tag;
    }
    int evaluateOid(ConsusStatement stmt) throws SQLException { 
	switch (tag) { 
	  case opGetOid:
	    return stmt.oid;
	  case opNull:
	    return 0;
	  case opFirst:
	    return stmt.cursor.table.firstRow;
	  case opLast:
	    return stmt.cursor.table.lastRow;
	  default:
	    Assert.failed("NULL, FIRST, LAST or OID expected");
	}
	return 0;
    }
    
    long evaluateInt(ConsusStatement stmt) throws SQLException {
	Assert.that(tag == opSysdate);
	return System.currentTimeMillis();
    }
    
    boolean evaluateBool(ConsusStatement stmt) throws SQLException { 
	return tag != opFalse;
    }

    ConstantNode(int type, int tag) { 
	super(type, tag);
    }
}

