/* Consus - Pure Java Object Relational Database Management System
 * Node for CREATE TABLE statement
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;
    
class CreateTableNode extends StmtNode { 
    TableDescriptor table;

    int executeStmt(ConsusStatement stmt) throws SQLException { 
	stmt.db.beginTransaction(true);
	if (stmt.db.tableHashByName.get(table.name) != null) { 
	    throw new ConsusRuntimeError("Table " + table.name + " already exists");
	}
	byte[] desc = table.exportDescriptor();
	table.tableId = stmt.db.allocateRow(stmt.db.metatable, desc);
	stmt.db.registerTable(table);
	for (FieldDescriptor fd = table.fields; fd != null; fd = fd.next) {
	    if ((fd.attr & FieldDescriptor.Indexed) != 0) { 
		fd.index = Btree.allocate(stmt.db, fd.type);
	    }
	}
	stmt.db.resetForeignKeyConstraints();
	stmt.db.endStatement();
	return 0;
    }
    
    CreateTableNode(TableDescriptor desc) { 
	super(tpVoid, opCreateTable);
	table = desc;
    }
}
