/* Consus - Pure Java Object Relational Database Management System
 * Node for DELETE statement
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;
    

class DeleteNode extends SelectNode { 
    int executeStmt(ConsusStatement stmt) throws SQLException { 
	int nSelected = 0;
	if (condition == null) { 
	    db = stmt.db;
	    nSelected = db.deleteTable(table);
	    db.endStatement();
	} else { 
	    int saveLimit = stmt.cursor.selectionLimit;
	    stmt.cursor.selectionLimit = Integer.MAX_VALUE;
	    nSelected = super.executeStmt(stmt);
	    stmt.cursor.selectionLimit = saveLimit;
	    for (int i = 0; i < nSelected; i++) { 
		db.freeRow(table, stmt.cursor.selection[i]);
	    }
	    stmt.cursor.close();
	}
	return nSelected;
    }

    DeleteNode(TableDescriptor desc, ExprNode criteria) { 
	super(opDelete, desc, criteria);
    }
}
