/* Consus - Pure Java Object Relational Database Management System
 * Node for dereferencing reference operation
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;


class DerefNode extends ExprNode { 
    ExprNode        base;
    FieldDescriptor field;
    
    String dump() { 
	return "(" + opMnem[tag] + " " + base.dump() + ")";
    }
    boolean equalsNode(ExprNode node) { 
	return (node instanceof DerefNode) && base.equalsNode(((DerefNode)node).base) 
	    && field == ((DerefNode)node).field;
    }

    int dependsOn() { 
	return base.dependsOn();
    }

    int evaluateBase(ConsusStatement stmt) throws SQLException { 
	int oid =  base.evaluateOid(stmt);
	if (oid == 0) { 
	    throw new ConsusRuntimeError("null reference");
	} 
	stmt.rec = stmt.db.get(oid);
	int tableId = Record.getType(stmt.rec, 0);
	TableDescriptor table = stmt.db.getTableByOid(tableId);
	if (!field.refTable.isSuperclassFor(table)) { 
	    throw new ConsusRuntimeError("Table " + field.refTable.name + " is not superclass for " 
					 + table.name);
	}	
	return 0;
    }

    DerefNode(ExprNode ref, FieldDescriptor fd) { 
	super(tpStructure, opDeref);
	base = ref;
	field = fd;
    }	
}
