/* Consus - Pure Java Object Relational Database Management System
 * Node for EXISTS operations
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;


class ExistsNode extends ExprNode {
    ExprNode expr;
    int      loopId;
    
    String dump() { 
	return "(" + opMnem[tag] + " " + expr.dump() + ")";
    }
    int dependsOn() { return expr.dependsOn(); }

    boolean evaluateBool(ConsusStatement stmt) throws SQLException { 
	stmt.indexVar[loopId] = 0;
	byte[] saveRec = stmt.rec;
	try { 
	    while (!expr.evaluateBool(stmt)) { 
		stmt.indexVar[loopId] += 1;
	    }
	    stmt.rec = saveRec;
	    return true;
	} catch (IndexOutOfRangeError x) { 
	    stmt.rec = saveRec;
	    if (x.loopId != loopId) { 
		throw x;
	    }
	    return false;
	}
    }
    
    ExistsNode(ExprNode expr, int loopId) { 
	super(tpBool, opExists);
	this.expr = expr;
	this.loopId = loopId;
    }
}
