/* Consus - Pure Java Object Relational Database Management System
 * Node for INSERT object statement
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;
    

class InsertObjectNode extends StmtNode { 
    TableDescriptor table;

    int executeStmt(ConsusStatement stmt) throws SQLException { 
	stmt.db.beginTransaction(true);
	Object obj = ((ConsusPreparedStatement)stmt).params[0].obj;
	int size = table.calculateRecordSize(obj);
	byte[] rec = new byte[size];
	table.allocateBlobs(rec, null, obj);
	table.storeObject(rec, obj);
	int oid = stmt.db.allocateRow(table, rec);
	int count = 1;
	if (table.insertInIndices(oid)) { 
	    stmt.db.freeRow(table, oid);
	    count = 0;
	}
	stmt.db.endStatement();
	return count;
    }

    InsertObjectNode(TableDescriptor desc) { 
	super(tpVoid, opInsertObject);
	table = desc;
    }
}

