/* Consus - Pure Java Object Relational Database Management System
 * Node for dereferencing reference operation
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;


class InstanceOfNode extends ExprNode { 
    ExprNode        base;
    TableDescriptor table;

    String dump() { 
	return "(" + opMnem[tag] + " " + table.name + " " + base.dump() + ")";
    }

    boolean equalsNode(ExprNode node) { 
	return (node instanceof InstanceOfNode) && base.equalsNode(((InstanceOfNode)node).base) 
	    && table == ((InstanceOfNode)node).table;
    }

    int dependsOn() { 
	return base.dependsOn();
    }

    boolean evaluateBool(ConsusStatement stmt) throws SQLException { 
	int oid = base.evaluateOid(stmt);
	if (oid == 0) { 
	    return false;
	} 
	int tableId = Record.getType(stmt.db.get(oid), 0);
	return table.isSuperclassFor(stmt.db.getTableByOid(tableId));
    }

    InstanceOfNode(ExprNode ref, TableDescriptor desc) { 
	super(tpBool, opInstanceOf);
	base = ref;
	table = desc;
    }	
}
