/* Consus - Pure Java Object Relational Database Management System
 * L2-List class used for implementation of LRU discipline for page pool
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

class LRU { 
    LRU next;
    LRU prev;

    LRU() 
    { 
	next = prev = this;
    }

    final void unlink() 
    { 
	next.prev = prev;
	prev.next = next;
    }

    final void link(LRU node) 
    { 
	node.next = next;
	node.prev = this;
	next.prev = node;
	next      = node;
    }
}

