/* Consus - Pure Java Object Relational Database Management System
 * Node representing '?' placeholder in JSQL statement.
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import java.sql.*;

class ParameterNode extends ExprNode { 
    boolean bval;
    long    ival;
    double  dval;
    String  sval;
    byte[]  aval;
    int     oid;
    Object  obj;

    int     itype; // iterator type
    boolean isSet;

    boolean evaluateBool(ConsusStatement stmt) throws SQLException { 
	return bval;
    }
    double evaluateReal(ConsusStatement stmt) throws SQLException { 
	return dval;
    }
    String evaluateStr(ConsusStatement stmt) throws SQLException { 
	return sval;
    }
    int evaluateOid(ConsusStatement stmt) throws SQLException { 
	return oid;
    }
    long evaluateInt(ConsusStatement stmt) throws SQLException { 
	return ival;
    }
    byte[] evaluateBinary(ConsusStatement stmt) throws SQLException { 
	return aval;
    }
    ParameterNode(int type) { 
	super(type, opParameter);
    }
}



