/* Consus - Pure Java Object Relational Database Management System
 * Node for compare operations with ALL/ANY quantors
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;


class QuantorNode extends ExprNode { 
    ExprNode condition;
    ExprNode subquery;
    Object[] set;
    Object   elem;

    String dump() { 
	return "(" + opMnem[tag] + " " + condition.dump() + ")";
    }
    boolean evaluateBool(ConsusStatement stmt) throws SQLException { 
	set = subquery.evaluateSet(stmt);
	int i;
	if (condition == null) { 
	    throw new ConsusRuntimeError("Quator is used not in compare operation");
	}
	switch (tag) { 
	  case opQuantorAll:
	    for (i = set.length; --i >= 0;) { 
		elem = set[i];
		if (!condition.evaluateBool(stmt)) { 
		    return false;
		}
	    }
	    return true;
	  case opQuantorAny:
	    for (i = set.length; --i >= 0;) { 
		elem = set[i];
		if (condition.evaluateBool(stmt)) { 
		    return true;
		}
	    }
	    return false;
	  default:
	    Assert.failed("Invalid quantor");
	    return false;
	}
    }

    QuantorNode(int tag, ExprNode subquery) { 
	super(tpBool, tag);
	this.subquery = subquery;
    }
}
