/* Consus - Pure Java Object Relational Database Management System
 * Common header for all Consus records(objects)
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

// 
// Each database record is prefixed by such header
//
class Record { 
    static final int sizeof = 4*4;

    static int getSize(byte[] arr, int offs) { 
	return Bytes.unpack4(arr, offs);   
    }
    static int getType(byte[] arr, int offs) { 
	return Bytes.unpack4(arr, offs+4);   
    }
    static int getNext(byte[] arr, int offs) { 
	return Bytes.unpack4(arr, offs+8); 
    }
    static int getPrev(byte[] arr, int offs) { 
	return Bytes.unpack4(arr, offs+12); 
    }

    static void setSize(byte[] arr, int offs, int size) { 
	Bytes.pack4(arr, offs, size);   
    }
    static void setType(byte[] arr, int offs, int type) { 
	Bytes.pack4(arr, offs+4, type);   
    }
    static void setNext(byte[] arr, int offs, int next) { 
	Bytes.pack4(arr, offs+8, next); 
    }
    static void setPrev(byte[] arr, int offs, int prev) { 
	Bytes.pack4(arr, offs+12, prev); 
    }
}

