/* Consus - Pure Java Object Relational Database Management System
 * Regular expression matching
 * Created by Konstantin Knizhnik, Jul 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;


public class Regexp { 
    public static final boolean matchString(String str, String pat, char esc) { 
	int pi = 0, si = 0, pn = pat.length(), sn = str.length(); 
	int wildcard = -1, strpos = -1;
	while (true) { 
	    if (pi < pn && pat.charAt(pi) == '%') { 
		wildcard = ++pi;
		strpos = si;
	    } else if (si == sn) { 
		return pi == pn;
	    } else if (pi+1 < pn && pat.charAt(pi) == esc && 
		       pat.charAt(pi+1) == str.charAt(si)) {
		si += 1;
		pi += 2;
	    } else if (pi < pn && ((pat.charAt(pi) != esc 
				    && (str.charAt(si) == pat.charAt(pi) 
					|| pat.charAt(pi) == '_')))) {
		si += 1;
		pi += 1;
	    } else if (wildcard >= 0) { 
		si = ++strpos;
		pi = wildcard;
	    } else { 
		return false;
	    }
	}
    }
}
