/* Consus - Pure Java Object Relational Database Management System
 * Node for string element access operation
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;


class StrGetAtNode extends ExprNode {
    ExprNode           left;
    ExprNode           right;

    String dump() { 
	return "(" + opMnem[tag] + " " + left.dump() + " " + right.dump() + ")";
    }
    boolean equalsNode(ExprNode node) { 
	return (node instanceof StrGetAtNode) && left.equalsNode(((StrGetAtNode)node).left) 
	    && right.equalsNode(((StrGetAtNode)node).right);
    }

    int dependsOn() { 
	return Math.max(left.dependsOn(), right.dependsOn());
    }


    long evaluateInt(ConsusStatement stmt) throws SQLException { 
	return left.evaluateStr(stmt).charAt((int)right.evaluateInt(stmt));
    }

    StrGetAtNode(ExprNode base, ExprNode index) { 
	super(tpInt, opStrGetAt);
	left = base;
	right = index;
    }
}
