/* Consus - Pure Java Object Relational Database Management System
 * Node for subquery in compare operations with quantor
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;


class SubqueryElemNode extends ExprNode { 
    QuantorNode quantor;

    boolean evaluateBool(ConsusStatement stmt) throws SQLException { 
	return ((Boolean)quantor.elem).booleanValue();
    }

    long evaluateLong(ConsusStatement stmt) throws SQLException { 
	return ((Long)quantor.elem).longValue();
    }

    double evaluateReal(ConsusStatement stmt) throws SQLException { 
	return ((Double)quantor.elem).doubleValue();
    }

    String evaluateStr(ConsusStatement stmt) throws SQLException { 
	return (String)quantor.elem;
    }

    int evaluateOid(ConsusStatement stmt) throws SQLException { 
	return (int)((ConsusRef)quantor.elem).getOid();
    }

    SubqueryElemNode(int tag, ExprNode expr) { 
	super(expr.type, opSubqueryElem);
	quantor = new QuantorNode(tag, expr);
    }
}
