/* Consus - Pure Java Object Relational Database Management System
 * Represents table in the select list
 * Created by Konstantin Knizhnik, Feb 2000.
 */

package org.garret.internal.consus;
import org.garret.consus.*;
import java.sql.SQLException;

class TableNode extends ExprNode { 
    TableNode       next;
    TableDescriptor table;
    String          name;
    int             index;
    int             projection[];
    JoinColumn      joinColumns;
    TableNode       joinTable;
    boolean         sequentialSearch;
    byte[]          rec;

    int evaluateBase(ConsusStatement stmt) throws SQLException { 
	stmt.rec = rec;
	return 0;
    }

    String dump() { 
	return "(" + opMnem[tag] + " " + name + ")";
    }
    int dependsOn() { 
	return index;
    }

    TableNode(TableDescriptor desc, int idx, TableNode chain) { 
	super(tpTable, opTable);
	name = desc.name;
	table = desc;
	index = idx;
	next = chain;
    }
};


