/* Consus - Pure Java Object Relational Database Management System
 * Node for dereferencing reference operation
 * Created by Konstantin Knizhnik, Feb 2000.
 */
package org.garret.internal.consus;
import org.garret.consus.*;

import  java.sql.SQLException;


class ThisInstanceOfNode extends ExprNode { 
    TableDescriptor table;

    String dump() { 
	return "(" + opMnem[tag] + " " + table.name + " " + ")";
    }

    boolean equalsNode(ExprNode node) { 
	return (node instanceof ThisInstanceOfNode) && table == ((ThisInstanceOfNode)node).table;
    }

    boolean evaluateBool(ConsusStatement stmt) throws SQLException { 
	int tableId = Record.getType(stmt.rec, 0);
	return table.isSuperclassFor(stmt.db.getTableByOid(tableId));
    }

    ThisInstanceOfNode(TableDescriptor desc) { 
	super(tpBool, opThisInstanceOf);
	table = desc;
    }	
}
