import java.sql.*;
import java.io.*;
import java.util.*;


public class TestSer {
    static final int nRecords = 100000;

    static public void main(String args[]) throws Exception { 
	// Parameter for Consus
	String DRIVER =   "org.garret.consus.ConsusDriver";
	String URL    =   "jdbc:consus:";
	String FILE   =   "TestSer.dbs";
	
	
	Class.forName(DRIVER);
	Connection connection = DriverManager.getConnection(URL + FILE);
	if (connection == null) { 
	    System.err.println("No connection with database " + FILE);
	    return;
	}
	connection.setAutoCommit(false);
	Statement stmt = connection.createStatement();
	
	stmt.executeUpdate("create table TestSer(componentId VARCHAR," + 
			   "version VARCHAR," + 
			   "status VARCHAR," + 
			   "name VARCHAR," + 
			   "rating INTEGER," +
			   "id BIGINT using index," + 
			   "downloads BIGINT," + 
			   "reviewDate BIGINT," + 
			   "submitDate BIGINT," + 
			   "authors VARBINARY)");
	PreparedStatement insert = 
	    connection.prepareStatement("insert into TestSer values (?,?,?,?,?,?,?,?,?,?)");
	int i;
	for (i = 0; i < nRecords; i++) { 
	    insert.setString(1, "id" + i);
	    insert.setString(2, "ver. 1");
	    insert.setString(3, "ok");
	    insert.setString(4, "name" + i);
	    insert.setInt(5, 1);
	    insert.setLong(6, i);
	    insert.setLong(7, 100);
	    insert.setLong(8, System.currentTimeMillis());
	    insert.setLong(9, System.currentTimeMillis());
	    Hashtable obj = new Hashtable();
	    obj.put("name" + i, "ok");
	    insert.setObject(10, obj, Types.VARBINARY);
	    insert.executeUpdate();
	}
	stmt.executeUpdate("update TestSer set rating = rating + 1");

	PreparedStatement update = 
	    connection.prepareStatement("update TestSer set status=?, authors=? where id=?");
	for (i = 0; i < nRecords; i++) { 
	    update.setString(1, "not ok");
	    Hashtable obj = new Hashtable();
	    obj.put("name" + i, "not ok" + i);
	    update.setObject(2, obj, Types.VARBINARY);
	    update.setLong(3, i);
	    update.executeUpdate();
	}
	PreparedStatement select = 
	    connection.prepareStatement("select * from TestSer where id=?");
	for (i = 0; i < nRecords; i++) { 
	    select.setLong(1, i);
	    ResultSet cursor = select.executeQuery();
	    if (cursor.next()) { 
		byte[] arr = cursor.getBytes(10);
		ObjectInputStream in = new ObjectInputStream(new ByteArrayInputStream(arr));
		Hashtable obj = new Hashtable();
		obj.put("name" + i, "not ok" + i);
		if (!obj.equals(in.readObject())) { 
		    System.out.println("Object not fetched properly");
		}
	    }
	    if (cursor.next()) { 
		System.err.println("Duplicated record");
	    }
	}

	select.close();
	select = connection.prepareStatement("select name,rating,authors from TestSer where id=?");
	for (i = 0; i < nRecords; i++) { 
	    select.setLong(1, i);
	    ResultSet cursor = select.executeQuery();
	    if (cursor.next()) { 
		byte[] arr = cursor.getBytes(3);
		ObjectInputStream in = new ObjectInputStream(new ByteArrayInputStream(arr));
		Hashtable obj = new Hashtable();
		obj.put("name" + i, "not ok" + i);
		if (!obj.equals(in.readObject())) { 
		    System.out.println("Object not fetched properly");
		}
	    }
	    if (cursor.next()) { 
		System.err.println("Duplicated record");
	    }
	}

	stmt.executeUpdate("drop table TestSer");
	connection.close();
    }
}
		
	    




