create table S (s$ 	char(5) primary key, 
		sname	char(20),
		status  integer,
		city    char(15));

create table P (p$ 	char(5) primary key,
		pname   char(20),
		color   char(6),
		weight  double,
		city    char(15));

create table J (j$ 	char(5) primary key,	
		jname   varchar,
		city    char(15));


create table SP(s$ 	char(5) using index,
		p$ 	char(5) using index,
		j$ 	char(5) using index,
		qty	bigint);


insert into S values('S1', 'Smith', 20, 'London');
insert into S values('S2', 'Jones', 10, 'Paris');
insert into S values('S3', 'Black', 30, 'Paris');
insert into S values('S4', 'Clark', 20, 'London');
insert into S values('S5', 'Adams', 30, 'Athens');

insert into P values('P1', 'Nut', 'Red', 12, 'London');
insert into P values('P2', 'Bolt', 'Green', 17, 'Paris');
insert into P values('P3', 'Screw', 'Blue', 17, 'Rome');
insert into P values('P4', 'Screw', 'Red', 14, 'London');
insert into P values('P5', 'Cam', 'Blue', 12, 'Paris');
insert into P values('P6', 'Cog', 'Red', 19, 'London');

insert into J values('J1', 'Sorter', 'Paris');
insert into J values('J2', 'Display', 'Rome');
insert into J values('J3', 'OCR', 'Athens');
insert into J values('J4', 'Console', 'Athens');
insert into J values('J5', 'RAID', 'London');
insert into J values('J6', 'EDS', 'Oslo');
insert into J values('J7', 'Tape', 'London');

insert into SP values('S1', 'P1', 'J1', 200);
insert into SP values('S1', 'P1', 'J4', 700);
insert into SP values('S2', 'P3', 'J1', 400);
insert into SP values('S2', 'P3', 'J2', 200);
insert into SP values('S2', 'P3', 'J3', 200);
insert into SP values('S2', 'P3', 'J4', 500);
insert into SP values('S2', 'P3', 'J5', 600);
insert into SP values('S2', 'P3', 'J6', 400);
insert into SP values('S2', 'P3', 'J7', 800);
insert into SP values('S2', 'P5', 'J2', 100);
insert into SP values('S3', 'P3', 'J1', 200);
insert into SP values('S3', 'P4', 'J2', 500);
insert into SP values('S4', 'P6', 'J3', 300);
insert into SP values('S4', 'P6', 'J7', 300);
insert into SP values('S5', 'P2', 'J2', 200);
insert into SP values('S5', 'P2', 'J4', 100);
insert into SP values('S5', 'P5', 'J5', 500);
insert into SP values('S5', 'P5', 'J7', 100);
insert into SP values('S5', 'P6', 'J2', 200);
insert into SP values('S5', 'P1', 'J4', 100);
insert into SP values('S5', 'P3', 'J4', 200);
insert into SP values('S5', 'P4', 'J4', 800);
insert into SP values('S5', 'P5', 'J4', 400);
insert into SP values('S5', 'P6', 'J4', 500);

select * from SP where s$='S2' and p$='P3' and (j$='J5' or j$='J7');

select P.color, P.city from P where P.city <> 'Paris' and P.weight > 10;

select distinct color, city from P where city <> 'Paris' and weight > 10;

select distinct P.color, P.city from P where P.city <> 'Paris' and weight > 10 order by city desc;

select p$, weight * 454 as GMWT from P;

select * from S;

select S.s$, S.sname, S.status, S.city, P.p$, P.pname, P.color, P.weight 
from S, P
where S.city = P.city;

select distinct S.city as scity, P.city as pcity from S, SP, P where S.s$ = SP.s$ and SP.p$ = P.p$;

select FRST.s$ as SA, SCND.s$ as SB 
from S as FRST, S as SCND 
where FRST.city = SCND.city and FRST.s$ < SCND.s$;

select count(*) N from S;

select max(SP.qty) as MAXQ, min (SP.qty) as MINQ from SP where SP.p$ = 'P2';

select SP.p$, SUM(SP.qty) as TOTQTY from SP group by SP.p$;

select p$ from SP group by p$ having count(s$) > 1;

select distinct S.sname from S where s$ in (select SP.s$ from SP where SP.p$ = 'P2');

select distinct S.sname from S where S.s$ in ('S1', 'S2', 'S3', 'S4'); 

select distinct sname from S, SP where S.s$ = SP.s$ and SP.p$ = 'P2';

select distinct sname from S where S.s$ in 
	(select SP.s$ from SP where SP.p$ in 
		(select P.p$ from P where P.color = 'Red' ));

select all S.s$ from S where status < (select MAX(status) from S);

select distinct S.sname from S where exists (SELECT * from SP where SP.s$ = S.s$ and SP.p$ = 'P2');

select distinct S.sname from S where not exists 
	(select * from SP where SP.p$ = S.s$ and SP.p$ = 'P2');

select distinct S.sname from S where S.s$ not in 
	(select SP.s$ from SP where SP.p$ = 'P2');

select distinct S.sname from S where not exists 
	(select * from P where not exists
		(select* from SP where SP.s$ = S.s$ and SP.p$ = P.p$));

select distinct S.sname from S where (select count(SP.p$) from SP where SP.s$ = S.s$)
	= (select count(P.p$) from P);	
	
select P.p$, 'Weight in grams = ' AS TEXT1, P.weight * 454 as GMWET, P.color, 'Max quantity = ' as TEST2, max(qty) as MQY
from P,SP
where P.p$ = SP.p$ and (P.color = 'Red' or P.color = 'Blue') and SP.qty > 200
group by P.p$, P.weight, P.color
having sum(SP.qty) > 350;

select distinct sname from S where S.s$ in
	(select SP.s$ from SP where SP.p$ = 'P2');

select distinct sname from S where S.s$ = any (select s$ from SP where p$ = 'P2');

select distinct S.sname from S where exists (select * from SP where SP.s$ = S.s$ and SP.p$ = 'P2');

select distinct S.sname from S, SP where S.s$ = SP.s$ and SP.p$ = 'P2';

select distinct sname from S where 0 < (select count(*) from SP where SP.s$ = S.s$ and SP.p$ = 'P2');

select distinct S.sname from S where 'P2' in (select SP.p$ from SP where SP.s$ = S.s$);

select distinct S.sname from S,SP where S.s$ = SP.s$ and SP.p$ = 'P2' group by S.sname;

select distinct SP.j$ from SP where SP.j$ = 'J1';
	
select SP.* from SP where qty >= 300 and qty < 750;

select distinct color,city from P;

select S.s$, P.p$, J.j$ from S, P, J where S.city = P.city and P.city = J.city;

select S.s$, P.p$, J.j$ from S, P, J where not (S.city = P.city and P.city = J.city);

select s$, p$, j$ from S, P, J where S.city <> P.city and P.city <> J.city and J.city <> P.city;

select distinct SP.p$ from SP where (select S.city from S where S.s$ = SP.s$) = 'London';

select distinct SP.p$ from SP where (select S.city from S where S.s$ = SP.s$) = 'London' 
	and (select J.city from J where J.j$ = SP.j$) = 'London';

select distinct S.city as SCITY, J.city as JCITY 
from S, J 
where exists (select * from SP where SP.s$ = S.s$ and SP.j$ = J.j$);

select distinct SP.p$ from SP where (select S.city from S where S.s$ = SP.s$) = 
	(select J.city from J where J.j$ = SP.j$);

select distinct SP.p$ from SP where (select S.city from S where S.s$ = SP.s$) <>
	(select J.city from J where J.j$ = SP.j$);

select distinct SPJX.p$ as PA, SPJY.p$ as PB 
from SP as SPJX, SP as SPJY 
where SPJX.s$ = SPJY.s$ and SPJX.p$ < SPJY.p$; 

select count(distinct SP.j$) as N from SP where SP.s$ = 'S1';

select sum(qty) as X from SP where SP.s$ = 'S1' and SP.p$ = 'P1';

select SP.p$, SP.j$, sum(SP.qty) as Y from SP group by p$, j$;

select distinct SP.p$ from SP group by SP.p$, SP.j$ having avg(SP.qty) > 320;

select distinct J.jname from J, SP where J.j$ = SP.j$ and SP.s$ = 'S1';

select distinct P.color from P, SP where P.p$ = SP.p$ and SP.s$ = 'S1';

select distinct SP.p$ from SP, J where SP.j$ = J.j$ and J.city = 'London';

select distinct SPJX.j$ from SP as SPJX, SP as SPJY 
where SPJX.p$ = SPJY.p$ and SPJY.s$ = 'S1';

select distinct SPJX.s$ from SP as SPJX, SP as SPJY, SP as SPJZ
where SPJX.p$ = SPJY.p$ and SPJY.s$ = SPJZ.s$ and (select P.color from P where P.p$ = SPJX.p$) = 'Red';

select S.s$ from S where status < (select status from S where s$ = 'S1');

select p$ from P where weight = (select min(weight) from P);

select distinct SPJX.j$ from SP as SPJX where SPJX.p$ = 'P1' and 	
	(select avg(SPJY.qty) from SP as SPJY where SPJY.j$ = SPJX.j$ and SPJY.p$ = 'P1') > 
	(select max (SPJZ.qty) from SP as SPJZ where SPJZ.j$ = 'J1');

select distinct SPJX.s$ from SP SPJX where SPJX.p$ = 'P1' and
	SPJX.qty > (select avg(SPJY.qty) from SP as SPJY where SPJY.p$ = 'P1' and SPJY.j$ = SPJX.j$);

select J.j$ from J where not exists (select * from S, P, SP 
	where SP.j$ = J.j$ and SP.p$ = P.p$ and SP.s$ = S.s$ and P.color = 'Red' and S.city = 'London');

select J.j$ from J where not exists (select * from SP, P, S 
	where SP.j$ = J.j$ and SP.p$ = P.p$ and SP.s$ = S.s$ and P.color = 'Red' and S.city = 'London');
	
select j$ from J where not exists (select * from SP where SP.j$ = J.j$ and NOT(SP.s$ = 'S1'));

select p$ from P where not exists 
	(select * from J where city = 'London' and not exists
		(select * from SP where SP.p$ = P.p$ and SP.j$ = J.j$));

select S.s$ from S where exists 
	(select * from P where not exists 
		(select * from J where not exists 
			(select * from SP where SP.s$ = S.s$ and SP.p$ = P.p$ and SP.j$ = J.j$)));

select J.j$ from J where not exists 
	(select * from SP as SPJX where SPJX.s$ = 'S1' and not exists 
		(select * from SP as SPJY where SPJY.p$ = SPJX.p$ and SPJY.j$ = J.j$));

select distinct SP.p$ from SP where 
	(select S.city from S where S.s$ = SP.s$) = 'London' or 
	(select J.city from J where J.j$ = SP.j$) = 'London';

	
select * from S join P using city;

select * from S natural join P;

select distinct S.city as SCITY, P.city as PCITY from S join SP using s$ join P using p$;

select distinct sname from S natural join SP where p$ = 'P2';

select distinct sname from S join SP using s$ where p$ = 'P2';

select distinct T.sname from (S natural join SP) as T where p$ = 'P2';

select distinct T.sname from (S join SP using s$) as T where T.p$ = 'P2';

select S.city from S union select P.city from P union select J.city from J; 

select S.city from S union all select P.city from P union all select J.city from J; 

select distinct SP.* from S natural join SP where p$ = 'P2';

select distinct * from (S natural join SP) as T where p$ = 'P2';

drop table S;
drop table P;
drop table J;
drop table SP;

exit